/* 
Originaly stealed from GPPL's (http://gppl.terminal.ru) autorecode-xmms1.2.7 patch,

csa8: changed to support limited size strings 

csa18: 
    Fixed error in binary search algorithm (start and end of the table realy wasn't used)
    UTF-8 support integrated
    New tables, new algorithm to detect even upercase phrases (~99.7% of right answers)

csa19:
    CP866 support
*/

typedef struct lng_stat {
  unsigned char a;
  unsigned char b;
  int rate;
} lng_stat;

//statistics calculated from "Moskva-Petushki"
static const lng_stat win[]={
{'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',8}, {'','',2}, {'','',2}, {'','',1}, {'','',4}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, 
{'','',1}, {'','',1}, {'','',6}, {'','',60}, {'','',5}, {'','',7}, {'','',23}, {'','',2}, {'','',6}, {'','',4}, {'','',1}, {'','',27}, {'','',15}, {'','',10}, {'','',25}, {'','',21}, 
{'','',51}, {'','',12}, {'','',13}, {'','',31}, {'','',15}, {'','',1}, {'','',6}, {'','',17}, {'','',8}, {'','',20}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',3}, {'','',2}, 
{'','',16}, {'','',1}, {'','',4}, {'','',3}, {'','',25}, {'','',10}, {'','',9}, {'','',8}, {'','',1}, {'','',2}, {'','',1}, {'','',3}, {'','',8}, {'','',2}, {'','',1}, {'','',2}, 
{'','',15}, {'','',2}, {'','',3}, {'','',5}, {'','',98}, {'','',5}, {'','',7}, {'','',5}, {'','',8}, {'','',7}, {'','',6}, {'','',107}, {'','',18}, {'','',2}, {'','',74}, {'','',6}, 
{'','',1}, {'','',3}, {'','',39}, {'','',8}, {'','',2}, {'','',6}, {'','',16}, {'','',26}, {'','',4}, {'','',3}, {'','',1}, {'','',31}, {'','',7}, {'','',2}, {'','',167}, {'','',6}, 
{'','',17}, {'','',3}, {'','',7}, {'','',3}, {'','',1}, {'','',20}, {'','',9}, {'','',19}, {'','',2}, {'','',1}, {'','',1}, {'','',9}, {'','',1}, {'','',1}, {'','',1}, {'','',5}, 
{'','',2}, {'','',19}, {'','',69}, {'','',1}, {'','',1}, {'','',5}, {'','',5}, {'','',1}, {'','',14}, {'','',5}, {'','',2}, {'','',1}, {'','',1}, {'','',31}, {'','',3}, {'','',1}, 
{'','',2}, {'','',23}, {'','',2}, {'','',12}, {'','',1}, {'','',1}, {'','',2}, {'','',2}, {'','',2}, {'','',2}, {'','',8}, {'','',78}, {'','',7}, {'','',20}, {'','',7}, {'','',1}, 
{'','',17}, {'','',3}, {'','',27}, {'','',15}, {'','',11}, {'','',21}, {'','',26}, {'','',21}, {'','',4}, {'','',21}, {'','',37}, {'','',5}, {'','',2}, {'','',3}, {'','',8}, {'','',1}, 
{'','',2}, {'','',12}, {'','',3}, {'','',100}, {'','',4}, {'','',1}, {'','',14}, {'','',4}, {'','',62}, {'','',2}, {'','',24}, {'','',10}, {'','',62}, {'','',1}, {'','',1}, {'','',2}, 
{'','',7}, {'','',11}, {'','',4}, {'','',12}, {'','',15}, {'','',3}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',31}, {'','',3}, {'','',1}, {'','',10}, {'','',44}, 
{'','',1}, {'','',19}, {'','',93}, {'','',1}, {'','',6}, {'','',29}, {'','',2}, {'','',1}, {'','',3}, {'','',56}, {'','',111}, {'','',47}, {'','',2}, {'','',98}, {'','',100}, {'','',1}, 
{'','',2}, {'','',6}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',18}, {'','',1}, {'','',4}, {'','',20}, {'','',2}, {'','',2}, {'','',7}, {'','',9}, {'','',2}, {'','',96}, 
{'','',5}, {'','',17}, {'','',16}, {'','',21}, {'','',35}, {'','',13}, {'','',1}, {'','',6}, {'','',3}, {'','',18}, {'','',148}, {'','',11}, {'','',9}, {'','',186}, {'','',43}, {'','',38}, 
{'','',4}, {'','',1}, {'','',22}, {'','',13}, {'','',5}, {'','',13}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',3}, {'','',19}, {'','',1}, {'','',4}, {'','',1}, {'','',56}, 
{'','',16}, {'','',22}, {'','',11}, {'','',12}, {'','',6}, {'','',26}, {'','',6}, {'','',6}, {'','',3}, {'','',35}, {'','',4}, {'','',2}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, 
{'','',4}, {'','',1}, {'','',1}, {'','',1}, {'','',79}, {'','',1}, {'','',18}, {'','',17}, {'','',34}, {'','',11}, {'','',31}, {'','',55}, {'','',2}, {'','',3}, {'','',2}, {'','',3}, 
{'','',1}, {'','',3}, {'','',2}, {'','',4}, {'','',4}, {'','',1}, {'','',2}, {'','',1}, {'','',2}, {'','',9}, {'','',5}, {'','',1}, {'','',1}, {'','',9}, {'','',8}, {'','',2}, 
{'','',1}, {'','',1}, {'','',1}, {'','',7}, {'','',2}, {'','',1}, {'','',16}, {'','',2}, {'','',1}, {'','',8}, {'','',1}, {'','',3}, {'','',20}, {'','',14}, {'','',7}, {'','',3}, 
{'','',1}, {'','',1}, {'','',1}, {'','',46}, {'','',60}, {'','',8}, {'','',1}, {'','',1}, {'','',3}, {'','',7}, {'','',8}, {'','',8}, {'','',7}, {'','',1}, {'','',1}, {'','',5}, 
{'','',1}, {'','',1}, {'','',4}, {'','',1}, {'','',10}, {'','',1}, {'','',61}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',4}, {'','',49}, {'','',5}, {'','',8}, {'','',9}, 
{'','',2}, {'','',12}, {'','',4}, {'','',10}, {'','',5}, {'','',6}, {'','',28}, {'','',24}, {'','',39}, {'','',4}, {'','',30}, {'','',7}, {'','',5}, {'','',3}, {'','',4}, {'','',3}, 
{'','',3}, {'','',56}, {'','',18}, {'','',48}, {'','',9}, {'','',26}, {'','',12}, {'','',7}, {'','',11}, {'','',53}, {'','',59}, {'','',9}, {'','',21}, {'','',32}, {'','',27}, {'','',52}, 
{'','',7}, {'','',21}, {'','',42}, {'','',10}, {'','',1}, {'','',4}, {'','',16}, {'','',2}, {'','',7}, {'','',22}, {'','',69}, {'','',257}, {'','',701}, {'','',218}, {'','',548}, {'','',328}, 
{'','',262}, {'','',626}, {'','',225}, {'','',194}, {'','',1285}, {'','',1288}, {'','',771}, {'','',911}, {'','',166}, {'','',421}, {'','',368}, {'','',802}, {'','',874}, {'','',98}, {'','',38}, {'','',228}, 
{'','',24}, {'','',300}, {'','',121}, {'','',27}, {'','',63}, {'','',238}, {'','',384}, {'','',1}, {'','',1}, {'','',1}, {'','',199}, {'','',6}, {'','',13}, {'','',6}, {'','',420}, {'','',2}, 
{'','',142}, {'','',7}, {'','',137}, {'','',7}, {'','',31}, {'','',327}, {'','',4}, {'','',172}, {'','',18}, {'','',1}, {'','',288}, {'','',11}, {'','',3}, {'','',2}, {'','',1}, {'','',32}, 
{'','',561}, {'','',10}, {'','',7}, {'','',1}, {'','',134}, {'','',11}, {'','',1}, {'','',6}, {'','',7}, {'','',5}, {'','',5}, {'','',6}, {'','',14}, {'','',2}, {'','',9}, {'','',13}, 
{'','',17}, {'','',51}, {'','',7}, {'','',18}, {'','',4}, {'','',2}, {'','',8}, {'','',1}, {'','',2}, {'','',7}, {'','',2}, {'','',4}, {'','',989}, {'','',26}, {'','',62}, {'','',43}, 
{'','',74}, {'','',911}, {'','',26}, {'','',88}, {'','',387}, {'','',1}, {'','',105}, {'','',122}, {'','',65}, {'','',231}, {'','',1220}, {'','',118}, {'','',97}, {'','',851}, {'','',123}, {'','',116}, 
{'','',1}, {'','',9}, {'','',11}, {'','',47}, {'','',53}, {'','',2}, {'','',518}, {'','',33}, {'','',44}, {'','',3}, {'','',48}, {'','',3}, {'','',1}, {'','',3}, {'','',1}, {'','',3}, 
{'','',3}, {'','',4}, {'','',1}, {'','',4}, {'','',3}, {'','',1}, {'','',2}, {'','',2}, {'','',1}, {'','',1}, {'','',2}, {'','',210}, {'','',18}, {'','',6}, {'','',3}, {'','',191}, 
{'','',83}, {'','',2}, {'','',103}, {'','',20}, {'','',205}, {'','',3}, {'','',62}, {'','',1340}, {'','',7}, {'','',180}, {'','',13}, {'','',4}, {'','',88}, {'','',1}, {'','',15}, {'','',1}, 
{'','',4}, {'','',1}, {'','',2}, {'','',2}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',2}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, {'','',2}, {'','',2}, {'','',795}, 
{'','',7}, {'','',165}, {'','',6}, {'','',14}, {'','',839}, {'','',8}, {'','',7}, {'','',487}, {'','',1}, {'','',79}, {'','',78}, {'','',10}, {'','',289}, {'','',613}, {'','',17}, {'','',195}, 
{'','',62}, {'','',41}, {'','',417}, {'','',1}, {'','',11}, {'','',138}, {'','',6}, {'','',111}, {'','',200}, {'','',6}, {'','',68}, {'','',30}, {'','',8}, {'','',33}, {'','',7}, {'','',34}, 
{'','',13}, {'','',1}, {'','',6}, {'','',21}, {'','',21}, {'','',4}, {'','',13}, {'','',20}, {'','',21}, {'','',31}, {'','',2}, {'','',13}, {'','',10}, {'','',7}, {'','',4}, {'','',2}, 
{'','',1}, {'','',9}, {'','',2}, {'','',11}, {'','',1}, {'','',25}, {'','',44}, {'','',463}, {'','',704}, {'','',592}, {'','',613}, {'','',281}, {'','',136}, {'','',444}, {'','',177}, {'','',297}, 
{'','',398}, {'','',926}, {'','',982}, {'','',1512}, {'','',206}, {'','',524}, {'','',1231}, {'','',1082}, {'','',1607}, {'','',103}, {'','',15}, {'','',182}, {'','',66}, {'','',308}, {'','',235}, {'','',137}, 
{'','',79}, {'','',24}, {'','',87}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',3}, {'','',187}, {'','',4}, {'','',9}, {'','',1}, {'','',145}, {'','',690}, {'','',4}, {'','',1}, 
{'','',214}, {'','',35}, {'','',1}, {'','',8}, {'','',96}, {'','',13}, {'','',14}, {'','',7}, {'','',4}, {'','',8}, {'','',69}, {'','',1}, {'','',1}, {'','',6}, {'','',2}, {'','',7}, 
{'','',1}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',4}, {'','',3}, {'','',1}, {'','',8}, {'','',4}, {'','',2}, {'','',1}, {'','',2}, {'','',2}, {'','',889}, {'','',39}, 
{'','',147}, {'','',67}, {'','',174}, {'','',56}, {'','',18}, {'','',11}, {'','',113}, {'','',16}, {'','',33}, {'','',64}, {'','',302}, {'','',109}, {'','',31}, {'','',53}, {'','',21}, {'','',7}, 
{'','',109}, {'','',3}, {'','',11}, {'','',4}, {'','',71}, {'','',20}, {'','',4}, {'','',43}, {'','',39}, {'','',10}, {'','',46}, {'','',5}, {'','',25}, {'','',11}, {'','',2}, {'','',1}, 
{'','',30}, {'','',24}, {'','',5}, {'','',36}, {'','',39}, {'','',25}, {'','',49}, {'','',3}, {'','',22}, {'','',25}, {'','',8}, {'','',3}, {'','',4}, {'','',2}, {'','',4}, {'','',3}, 
{'','',7}, {'','',28}, {'','',90}, {'','',242}, {'','',658}, {'','',153}, {'','',435}, {'','',280}, {'','',87}, {'','',388}, {'','',301}, {'','',216}, {'','',492}, {'','',888}, {'','',573}, {'','',958}, 
{'','',216}, {'','',335}, {'','',275}, {'','',668}, {'','',949}, {'','',108}, {'','',17}, {'','',324}, {'','',123}, {'','',363}, {'','',134}, {'','',36}, {'','',39}, {'','',22}, {'','',234}, {'','',20}, 
{'','',6}, {'','',20}, {'','',6}, {'','',16}, {'','',6}, {'','',2}, {'','',22}, {'','',18}, {'','',2}, {'','',12}, {'','',13}, {'','',15}, {'','',13}, {'','',7}, {'','',9}, {'','',15}, 
{'','',3}, {'','',1}, {'','',1}, {'','',1}, {'','',7}, {'','',8}, {'','',21}, {'','',36}, {'','',112}, {'','',26}, {'','',100}, {'','',15}, {'','',21}, {'','',30}, {'','',88}, {'','',1}, 
{'','',87}, {'','',25}, {'','',47}, {'','',117}, {'','',55}, {'','',133}, {'','',42}, {'','',162}, {'','',131}, {'','',17}, {'','',6}, {'','',7}, {'','',11}, {'','',69}, {'','',20}, {'','',2}, 
{'','',15}, {'','',16}, {'','',11}, {'','',13}, {'','',7}, {'','',4}, {'','',2}, {'','',1}, {'','',5}, {'','',8}, {'','',9}, {'','',2}, {'','',5}, {'','',20}, {'','',7}, {'','',9}, 
{'','',7}, {'','',9}, {'','',4}, {'','',1}, {'','',1}, {'','',4}, {'','',2}, {'','',8}, {'','',1358}, {'','',49}, {'','',147}, {'','',15}, {'','',48}, {'','',93}, {'','',22}, {'','',55}, 
{'','',678}, {'','',28}, {'','',81}, {'','',22}, {'','',151}, {'','',1337}, {'','',64}, {'','',273}, {'','',131}, {'','',238}, {'','',384}, {'','',7}, {'','',10}, {'','',5}, {'','',31}, {'','',2}, 
{'','',2}, {'','',13}, {'','',25}, {'','',20}, {'','',2}, {'','',25}, {'','',5}, {'','',14}, {'','',3}, {'','',1}, {'','',19}, {'','',12}, {'','',2}, {'','',14}, {'','',31}, {'','',20}, 
{'','',20}, {'','',1}, {'','',20}, {'','',10}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',2}, {'','',4}, {'','',19}, {'','',758}, {'','',34}, {'','',102}, {'','',35}, {'','',55}, 
{'','',675}, {'','',33}, {'','',23}, {'','',1300}, {'','',1}, {'','',114}, {'','',21}, {'','',45}, {'','',111}, {'','',947}, {'','',83}, {'','',18}, {'','',320}, {'','',61}, {'','',264}, {'','',5}, 
{'','',7}, {'','',2}, {'','',66}, {'','',1}, {'','',146}, {'','',642}, {'','',21}, {'','',159}, {'','',299}, {'','',11}, {'','',2}, {'','',14}, {'','',8}, {'','',10}, {'','',1}, {'','',5}, 
{'','',12}, {'','',10}, {'','',6}, {'','',23}, {'','',12}, {'','',12}, {'','',1}, {'','',9}, {'','',16}, {'','',2}, {'','',2}, {'','',3}, {'','',1}, {'','',1}, {'','',10}, {'','',447}, 
{'','',69}, {'','',119}, {'','',33}, {'','',41}, {'','',838}, {'','',27}, {'','',38}, {'','',484}, {'','',2}, {'','',71}, {'','',74}, {'','',96}, {'','',497}, {'','',761}, {'','',132}, {'','',41}, 
{'','',137}, {'','',74}, {'','',411}, {'','',5}, {'','',13}, {'','',4}, {'','',46}, {'','',3}, {'','',3}, {'','',207}, {'','',33}, {'','',17}, {'','',82}, {'','',11}, {'','',5}, {'','',8}, 
{'','',3}, {'','',4}, {'','',7}, {'','',10}, {'','',1}, {'','',2}, {'','',6}, {'','',2}, {'','',9}, {'','',2}, {'','',2}, {'','',6}, {'','',1}, {'','',1}, {'','',6}, {'','',1}, 
{'','',2}, {'','',2}, {'','',1706}, {'','',28}, {'','',55}, {'','',48}, {'','',97}, {'','',1870}, {'','',5}, {'','',20}, {'','',1319}, {'','',84}, {'','',7}, {'','',11}, {'','',331}, {'','',1483}, 
{'','',54}, {'','',27}, {'','',133}, {'','',165}, {'','',480}, {'','',14}, {'','',4}, {'','',65}, {'','',55}, {'','',3}, {'','',31}, {'','',385}, {'','',196}, {'','',7}, {'','',30}, {'','',396}, 
{'','',34}, {'','',5}, {'','',44}, {'','',9}, {'','',16}, {'','',16}, {'','',4}, {'','',17}, {'','',43}, {'','',17}, {'','',3}, {'','',23}, {'','',49}, {'','',23}, {'','',40}, {'','',6}, 
{'','',14}, {'','',19}, {'','',4}, {'','',7}, {'','',4}, {'','',2}, {'','',12}, {'','',5}, {'','',27}, {'','',34}, {'','',652}, {'','',1590}, {'','',915}, {'','',946}, {'','',457}, {'','',437}, 
{'','',279}, {'','',291}, {'','',602}, {'','',498}, {'','',923}, {'','',1073}, {'','',1281}, {'','',241}, {'','',588}, {'','',921}, {'','',1264}, {'','',1536}, {'','',152}, {'','',35}, {'','',137}, {'','',51}, 
{'','',459}, {'','',223}, {'','',56}, {'','',89}, {'','',81}, {'','',154}, {'','',2}, {'','',1}, {'','',1}, {'','',252}, {'','',1}, {'','',1}, {'','',364}, {'','',356}, {'','',8}, {'','',189}, 
{'','',11}, {'','',1543}, {'','',6}, {'','',845}, {'','',6}, {'','',23}, {'','',202}, {'','',2}, {'','',33}, {'','',122}, {'','',149}, {'','',3}, {'','',4}, {'','',3}, {'','',6}, {'','',2}, 
{'','',1}, {'','',2}, {'','',1}, {'','',5}, {'','',8}, {'','',10}, {'','',2}, {'','',4}, {'','',2}, {'','',1}, {'','',2}, {'','',3}, {'','',6}, {'','',1264}, {'','',29}, {'','',98}, 
{'','',53}, {'','',129}, {'','',936}, {'','',41}, {'','',20}, {'','',777}, {'','',1}, {'','',54}, {'','',29}, {'','',39}, {'','',181}, {'','',1126}, {'','',38}, {'','',34}, {'','',76}, {'','',122}, 
{'','',355}, {'','',8}, {'','',36}, {'','',23}, {'','',9}, {'','',49}, {'','',5}, {'','',169}, {'','',98}, {'','',7}, {'','',59}, {'','',159}, {'','',6}, {'','',4}, {'','',2}, {'','',2}, 
{'','',1}, {'','',1}, {'','',4}, {'','',2}, {'','',3}, {'','',4}, {'','',5}, {'','',3}, {'','',3}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',3}, {'','',1}, {'','',306}, 
{'','',33}, {'','',259}, {'','',18}, {'','',41}, {'','',973}, {'','',8}, {'','',11}, {'','',295}, {'','',691}, {'','',519}, {'','',222}, {'','',236}, {'','',403}, {'','',274}, {'','',58}, {'','',222}, 
{'','',1721}, {'','',146}, {'','',18}, {'','',34}, {'','',6}, {'','',48}, {'','',20}, {'','',2}, {'','',79}, {'','',401}, {'','',10}, {'','',27}, {'','',680}, {'','',29}, {'','',5}, {'','',25}, 
{'','',3}, {'','',11}, {'','',9}, {'','',2}, {'','',5}, {'','',16}, {'','',21}, {'','',20}, {'','',24}, {'','',10}, {'','',23}, {'','',2}, {'','',10}, {'','',13}, {'','',2}, {'','',2}, 
{'','',3}, {'','',11}, {'','',1}, {'','',3}, {'','',1}, {'','',16}, {'','',1225}, {'','',56}, {'','',436}, {'','',25}, {'','',67}, {'','',864}, {'','',17}, {'','',33}, {'','',758}, {'','',1}, 
{'','',180}, {'','',52}, {'','',65}, {'','',329}, {'','',2625}, {'','',119}, {'','',616}, {'','',337}, {'','',117}, {'','',398}, {'','',1}, {'','',24}, {'','',10}, {'','',87}, {'','',3}, {'','',4}, 
{'','',398}, {'','',1292}, {'','',37}, {'','',13}, {'','',103}, {'','',22}, {'','',4}, {'','',19}, {'','',4}, {'','',20}, {'','',3}, {'','',2}, {'','',25}, {'','',9}, {'','',6}, {'','',12}, 
{'','',18}, {'','',13}, {'','',18}, {'','',1}, {'','',18}, {'','',12}, {'','',2}, {'','',2}, {'','',5}, {'','',6}, {'','',3}, {'','',5}, {'','',17}, {'','',45}, {'','',142}, {'','',184}, 
{'','',161}, {'','',445}, {'','',83}, {'','',269}, {'','',75}, {'','',111}, {'','',40}, {'','',169}, {'','',251}, {'','',322}, {'','',195}, {'','',50}, {'','',258}, {'','',203}, {'','',380}, {'','',442}, 
{'','',24}, {'','',5}, {'','',97}, {'','',241}, {'','',302}, {'','',37}, {'','',19}, {'','',156}, {'','',31}, {'','',1}, {'','',2}, {'','',21}, {'','',45}, {'','',47}, {'','',14}, {'','',2}, 
{'','',24}, {'','',20}, {'','',4}, {'','',5}, {'','',8}, {'','',6}, {'','',4}, {'','',1}, {'','',2}, {'','',7}, {'','',7}, {'','',4}, {'','',3}, {'','',3}, {'','',5}, {'','',4}, 
{'','',2}, {'','',1}, {'','',10}, {'','',5}, {'','',7}, {'','',4}, {'','',5}, {'','',3}, {'','',5}, {'','',2}, {'','',5}, {'','',135}, {'','',21}, {'','',72}, {'','',27}, {'','',21}, 
{'','',25}, {'','',4}, {'','',13}, {'','',75}, {'','',16}, {'','',43}, {'','',49}, {'','',83}, {'','',450}, {'','',70}, {'','',19}, {'','',39}, {'','',27}, {'','',42}, {'','',3}, {'','',4}, 
{'','',2}, {'','',18}, {'','',8}, {'','',1}, {'','',6}, {'','',7}, {'','',9}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, 
{'','',179}, {'','',1}, {'','',11}, {'','',162}, {'','',5}, {'','',75}, {'','',6}, {'','',5}, {'','',1}, {'','',2}, {'','',29}, {'','',4}, {'','',2}, {'','',4}, {'','',4}, {'','',41}, 
{'','',2}, {'','',41}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',3}, {'','',1}, {'','',3}, {'','',2}, {'','',1}, {'','',294}, {'','',1}, {'','',6}, {'','',874}, {'','',319}, 
{'','',76}, {'','',9}, {'','',4}, {'','',158}, {'','',10}, {'','',3}, {'','',8}, {'','',2}, {'','',536}, {'','',101}, {'','',7}, {'','',37}, {'','',49}, {'','',1}, {'','',1}, {'','',150}, 
{'','',5}, {'','',388}, {'','',188}, {'','',201}, {'','',68}, {'','',4}, {'','',78}, {'','',53}, {'','',8}, {'','',3}, {'','',2}, {'','',17}, {'','',45}, {'','',1}, {'','',1}, {'','',200}, 
{'','',1}, {'','',1}, {'','',1}, {'','',68}, {'','',242}, {'','',96}, {'','',7}, {'','',1}, {'','',1}, {'','',3}, {'','',20}, {'','',2}, {'','',14}, {'','',6}, {'','',28}, {'','',4}, 
{'','',8}, {'','',6}, {'','',1}, {'','',4}, {'','',12}, {'','',10}, {'','',2}, {'','',15}, {'','',16}, {'','',13}, {'','',6}, {'','',3}, {'','',7}, {'','',10}, {'','',1}, {'','',1}, 
{'','',4}, {'','',5}, {'','',1}, {'','',10}, {'','',10}, {'','',66}, {'','',248}, {'','',37}, {'','',65}, {'','',138}, {'','',21}, {'','',45}, {'','',74}, {'','',264}, {'','',83}, {'','',305}, 
{'','',164}, {'','',141}, {'','',34}, {'','',231}, {'','',61}, {'','',189}, {'','',148}, {'','',35}, {'','',1}, {'','',146}, {'','',3}, {'','',63}, {'','',80}, {'','',1}, {'','',9}, {'','',10}, 
{'','',44}, {'','',8}, {'','',45}, {'','',7}, {'','',18}, {'','',12}, {'','',1}, {'','',4}, {'','',29}, {'','',19}, {'','',18}, {'','',36}, {'','',25}, {'','',42}, {'','',4}, {'','',25}, 
{'','',24}, {'','',10}, {'','',1}, {'','',3}, {'','',14}, {'','',1}, {'','',4}, {'','',21}, {'','',38}, {'','',63}, {'','',196}, {'','',35}, {'','',110}, {'','',154}, {'','',11}, {'','',58}, 
{'','',194}, {'','',1}, {'','',324}, {'','',36}, {'','',124}, {'','',321}, {'','',92}, {'','',164}, {'','',41}, {'','',302}, {'','',152}, {'','',48}, {'','',5}, {'','',20}, {'','',15}, {'','',88}, 
{'','',85}, {'','',1}, {'','',27}, {'','',88}, {'','',110}, {'','',1}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',6}, {'','',9}, {'','',6}, {'','',3}, {'','',8}, {'','',4}, 
{'','',531}, {'','',2}, {'','',1}, {'','',2}, {'','',10}, {'','',1}, {'','',10}, {'','',1}, {'','',3}, {'','',1}, {'','',2}, {'','',17}, {'','',4}, {'','',2}, {'','',3}, {'','',16}, 
{'','',4}, {'','',5}, {'','',1}, {'','',3}, {'','',2}, {'','',2}, {'','',3}, {'','',1}, {'','',2}, {'','',2}, {'','',9}, {'','',15}, {'','',73}, {'','',37}, {'','',12}, {'','',72}, 
{'','',12}, {'','',6}, {'','',11}, {'','',45}, {'','',1}, {'','',30}, {'','',9}, {'','',28}, {'','',58}, {'','',17}, {'','',58}, {'','',14}, {'','',71}, {'','',139}, {'','',10}, {'','',5}, 
{'','',5}, {'','',3}, {'','',42}, {'','',11}, {'','',27}, {'','',2}, {'','',10}, {'','',20}, {'','',18}, {'','',5}, {'','',28}, {'','',2}, {'','',23}, {'','',6}, {'','',2}, {'','',3}, 
{'','',15}, {'','',14}, {'','',3}, {'','',10}, {'','',23}, {'','',22}, {'','',26}, {'','',5}, {'','',12}, {'','',17}, {'','',1}, {'','',2}, {'','',1}, {'','',7}, {'','',2}, {'','',10}, 
{'','',18}, {'','',23}, {'','',85}, {'','',260}, {'','',44}, {'','',170}, {'','',70}, {'','',63}, {'','',114}, {'','',146}, {'','',7}, {'','',145}, {'','',137}, {'','',108}, {'','',275}, {'','',110}, 
{'','',204}, {'','',43}, {'','',259}, {'','',457}, {'','',64}, {'','',2}, {'','',37}, {'','',18}, {'','',75}, {'','',13}, {'','',33}, {'','',22}, {'','',31}, {'','',47}
};

static const lng_stat koi[]={
{'','',10}, {'','',15}, {'','',73}, {'','',3}, {'','',72}, {'','',12}, {'','',5}, {'','',12}, {'','',5}, {'','',45}, {'','',1}, {'','',30}, {'','',9}, {'','',28}, {'','',58}, {'','',17}, 
{'','',58}, {'','',20}, {'','',14}, {'','',71}, {'','',139}, {'','',10}, {'','',6}, {'','',37}, {'','',11}, {'','',11}, {'','',2}, {'','',27}, {'','',42}, {'','',10}, {'','',1}, {'','',3}, 
{'','',1}, {'','',3}, {'','',17}, {'','',4}, {'','',2}, {'','',3}, {'','',16}, {'','',4}, {'','',5}, {'','',9}, {'','',1}, {'','',3}, {'','',2}, {'','',2}, {'','',1}, {'','',10}, 
{'','',2}, {'','',2}, {'','',2}, {'','',1}, {'','',238}, {'','',69}, {'','',257}, {'','',24}, {'','',548}, {'','',328}, {'','',38}, {'','',218}, {'','',228}, {'','',225}, {'','',194}, {'','',1285}, 
{'','',1288}, {'','',771}, {'','',911}, {'','',166}, {'','',421}, {'','',384}, {'','',368}, {'','',802}, {'','',874}, {'','',98}, {'','',262}, {'','',701}, {'','',626}, {'','',121}, {'','',63}, {'','',27}, 
{'','',300}, {'','',56}, {'','',18}, {'','',26}, {'','',12}, {'','',1}, {'','',9}, {'','',4}, {'','',53}, {'','',59}, {'','',9}, {'','',21}, {'','',32}, {'','',27}, {'','',52}, {'','',22}, 
{'','',7}, {'','',21}, {'','',42}, {'','',10}, {'','',7}, {'','',48}, {'','',11}, {'','',2}, {'','',7}, {'','',16}, {'','',1}, {'','',199}, {'','',6}, {'','',3}, {'','',6}, {'','',420}, 
{'','',11}, {'','',142}, {'','',7}, {'','',137}, {'','',7}, {'','',31}, {'','',327}, {'','',4}, {'','',134}, {'','',172}, {'','',18}, {'','',1}, {'','',288}, {'','',13}, {'','',10}, {'','',561}, 
{'','',2}, {'','',1}, {'','',7}, {'','',32}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, {'','',179}, {'','',1}, {'','',162}, {'','',75}, {'','',6}, {'','',5}, {'','',1}, {'','',2}, 
{'','',29}, {'','',4}, {'','',2}, {'','',4}, {'','',4}, {'','',41}, {'','',11}, {'','',41}, {'','',5}, {'','',2}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, 
{'','',1}, {'','',1}, {'','',1}, {'','',795}, {'','',7}, {'','',138}, {'','',14}, {'','',839}, {'','',1}, {'','',6}, {'','',11}, {'','',487}, {'','',1}, {'','',79}, {'','',78}, {'','',10}, 
{'','',289}, {'','',613}, {'','',17}, {'','',68}, {'','',195}, {'','',62}, {'','',41}, {'','',417}, {'','',8}, {'','',165}, {'','',200}, {'','',111}, {'','',7}, {'','',6}, {'','',6}, {'','',1}, 
{'','',2}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',2}, {'','',2}, {'','',2}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',2}, {'','',24}, {'','',44}, {'','',463}, 
{'','',66}, {'','',613}, {'','',281}, {'','',15}, {'','',592}, {'','',182}, {'','',177}, {'','',297}, {'','',398}, {'','',926}, {'','',982}, {'','',1512}, {'','',206}, {'','',524}, {'','',87}, {'','',1231}, 
{'','',1082}, {'','',1607}, {'','',103}, {'','',136}, {'','',704}, {'','',444}, {'','',235}, {'','',79}, {'','',137}, {'','',308}, {'','',1}, {'','',30}, {'','',8}, {'','',1}, {'','',34}, {'','',13}, 
{'','',4}, {'','',7}, {'','',2}, {'','',21}, {'','',21}, {'','',4}, {'','',13}, {'','',20}, {'','',21}, {'','',31}, {'','',25}, {'','',2}, {'','',13}, {'','',10}, {'','',7}, {'','',1}, 
{'','',33}, {'','',6}, {'','',2}, {'','',11}, {'','',9}, {'','',2}, {'','',21}, {'','',45}, {'','',6}, {'','',47}, {'','',14}, {'','',2}, {'','',24}, {'','',20}, {'','',4}, {'','',5}, 
{'','',8}, {'','',1}, {'','',4}, {'','',2}, {'','',1}, {'','',210}, {'','',18}, {'','',191}, {'','',83}, {'','',3}, {'','',1}, {'','',103}, {'','',20}, {'','',205}, {'','',3}, {'','',62}, 
{'','',1340}, {'','',7}, {'','',4}, {'','',180}, {'','',13}, {'','',4}, {'','',88}, {'','',6}, {'','',2}, {'','',1}, {'','',15}, {'','',3}, {'','',1}, {'','',1}, {'','',3}, {'','',4}, 
{'','',1}, {'','',4}, {'','',3}, {'','',2}, {'','',1}, {'','',2}, {'','',2}, {'','',3}, {'','',3}, {'','',1}, {'','',1}, {'','',135}, {'','',21}, {'','',2}, {'','',21}, {'','',25}, 
{'','',3}, {'','',27}, {'','',4}, {'','',75}, {'','',16}, {'','',43}, {'','',49}, {'','',83}, {'','',450}, {'','',70}, {'','',9}, {'','',19}, {'','',39}, {'','',27}, {'','',42}, {'','',4}, 
{'','',72}, {'','',6}, {'','',1}, {'','',13}, {'','',8}, {'','',7}, {'','',18}, {'','',7}, {'','',4}, {'','',3}, {'','',5}, {'','',4}, {'','',2}, {'','',1}, {'','',10}, {'','',5}, 
{'','',7}, {'','',5}, {'','',4}, {'','',5}, {'','',3}, {'','',7}, {'','',5}, {'','',2}, {'','',3}, {'','',22}, {'','',90}, {'','',242}, {'','',123}, {'','',435}, {'','',280}, {'','',17}, 
{'','',153}, {'','',324}, {'','',301}, {'','',216}, {'','',492}, {'','',888}, {'','',573}, {'','',958}, {'','',216}, {'','',335}, {'','',234}, {'','',275}, {'','',668}, {'','',949}, {'','',108}, {'','',87}, 
{'','',658}, {'','',388}, {'','',134}, {'','',39}, {'','',36}, {'','',363}, {'','',39}, {'','',10}, {'','',2}, {'','',25}, {'','',11}, {'','',3}, {'','',5}, {'','',4}, {'','',30}, {'','',24}, 
{'','',5}, {'','',36}, {'','',39}, {'','',25}, {'','',49}, {'','',28}, {'','',3}, {'','',22}, {'','',25}, {'','',8}, {'','',2}, {'','',46}, {'','',1}, {'','',3}, {'','',7}, {'','',4}, 
{'','',21}, {'','',36}, {'','',11}, {'','',100}, {'','',15}, {'','',6}, {'','',26}, {'','',7}, {'','',88}, {'','',1}, {'','',87}, {'','',25}, {'','',47}, {'','',117}, {'','',55}, {'','',133}, 
{'','',16}, {'','',42}, {'','',162}, {'','',131}, {'','',17}, {'','',21}, {'','',112}, {'','',30}, {'','',20}, {'','',15}, {'','',2}, {'','',69}, {'','',20}, {'','',6}, {'','',16}, {'','',6}, 
{'','',1}, {'','',6}, {'','',1}, {'','',22}, {'','',18}, {'','',2}, {'','',12}, {'','',13}, {'','',15}, {'','',13}, {'','',8}, {'','',7}, {'','',9}, {'','',15}, {'','',3}, {'','',20}, 
{'','',2}, {'','',7}, {'','',1}, {'','',1358}, {'','',49}, {'','',5}, {'','',48}, {'','',93}, {'','',7}, {'','',15}, {'','',10}, {'','',678}, {'','',28}, {'','',81}, {'','',22}, {'','',151}, 
{'','',1337}, {'','',64}, {'','',25}, {'','',273}, {'','',131}, {'','',238}, {'','',384}, {'','',22}, {'','',147}, {'','',2}, {'','',55}, {'','',2}, {'','',13}, {'','',31}, {'','',11}, {'','',1}, 
{'','',4}, {'','',2}, {'','',7}, {'','',1}, {'','',8}, {'','',9}, {'','',2}, {'','',5}, {'','',20}, {'','',7}, {'','',9}, {'','',8}, {'','',7}, {'','',9}, {'','',4}, {'','',1}, 
{'','',13}, {'','',5}, {'','',2}, {'','',4}, {'','',159}, {'','',758}, {'','',34}, {'','',2}, {'','',55}, {'','',675}, {'','',5}, {'','',35}, {'','',7}, {'','',1300}, {'','',1}, {'','',114}, 
{'','',21}, {'','',45}, {'','',111}, {'','',947}, {'','',83}, {'','',299}, {'','',18}, {'','',320}, {'','',61}, {'','',264}, {'','',33}, {'','',102}, {'','',642}, {'','',146}, {'','',23}, {'','',1}, 
{'','',21}, {'','',66}, {'','',20}, {'','',2}, {'','',1}, {'','',14}, {'','',3}, {'','',1}, {'','',5}, {'','',1}, {'','',19}, {'','',12}, {'','',2}, {'','',14}, {'','',31}, {'','',20}, 
{'','',20}, {'','',19}, {'','',1}, {'','',20}, {'','',10}, {'','',1}, {'','',1}, {'','',25}, {'','',4}, {'','',2}, {'','',447}, {'','',69}, {'','',4}, {'','',41}, {'','',838}, {'','',5}, 
{'','',33}, {'','',13}, {'','',484}, {'','',2}, {'','',71}, {'','',74}, {'','',96}, {'','',497}, {'','',761}, {'','',132}, {'','',82}, {'','',41}, {'','',137}, {'','',74}, {'','',411}, {'','',27}, 
{'','',119}, {'','',33}, {'','',207}, {'','',38}, {'','',3}, {'','',17}, {'','',3}, {'','',46}, {'','',11}, {'','',2}, {'','',10}, {'','',1}, {'','',8}, {'','',2}, {'','',12}, {'','',10}, 
{'','',6}, {'','',23}, {'','',12}, {'','',12}, {'','',10}, {'','',1}, {'','',9}, {'','',16}, {'','',2}, {'','',14}, {'','',5}, {'','',1}, {'','',1}, {'','',3}, {'','',30}, {'','',1706}, 
{'','',28}, {'','',65}, {'','',97}, {'','',1870}, {'','',14}, {'','',48}, {'','',4}, {'','',1319}, {'','',84}, {'','',7}, {'','',11}, {'','',331}, {'','',1483}, {'','',54}, {'','',396}, {'','',27}, 
{'','',133}, {'','',165}, {'','',480}, {'','',5}, {'','',55}, {'','',196}, {'','',385}, {'','',20}, {'','',3}, {'','',7}, {'','',31}, {'','',55}, {'','',11}, {'','',1}, {'','',3}, {'','',4}, 
{'','',8}, {'','',7}, {'','',10}, {'','',1}, {'','',2}, {'','',6}, {'','',2}, {'','',9}, {'','',2}, {'','',2}, {'','',2}, {'','',6}, {'','',1}, {'','',5}, {'','',1}, {'','',2}, 
{'','',6}, {'','',81}, {'','',34}, {'','',652}, {'','',51}, {'','',946}, {'','',457}, {'','',35}, {'','',915}, {'','',137}, {'','',291}, {'','',602}, {'','',498}, {'','',923}, {'','',1073}, {'','',1281}, 
{'','',241}, {'','',588}, {'','',154}, {'','',921}, {'','',1264}, {'','',1536}, {'','',152}, {'','',437}, {'','',1590}, {'','',279}, {'','',223}, {'','',89}, {'','',56}, {'','',459}, {'','',34}, {'','',5}, 
{'','',2}, {'','',16}, {'','',16}, {'','',7}, {'','',9}, {'','',4}, {'','',43}, {'','',17}, {'','',3}, {'','',23}, {'','',49}, {'','',23}, {'','',40}, {'','',27}, {'','',6}, {'','',14}, 
{'','',19}, {'','',4}, {'','',4}, {'','',44}, {'','',17}, {'','',5}, {'','',12}, {'','',252}, {'','',1}, {'','',364}, {'','',356}, {'','',8}, {'','',189}, {'','',11}, {'','',1543}, {'','',6}, 
{'','',149}, {'','',845}, {'','',6}, {'','',23}, {'','',202}, {'','',1}, {'','',122}, {'','',33}, {'','',2}, {'','',1}, {'','',1}, {'','',2}, {'','',31}, {'','',23}, {'','',85}, {'','',18}, 
{'','',170}, {'','',70}, {'','',2}, {'','',44}, {'','',37}, {'','',146}, {'','',7}, {'','',145}, {'','',137}, {'','',108}, {'','',275}, {'','',110}, {'','',204}, {'','',47}, {'','',43}, {'','',259}, 
{'','',457}, {'','',64}, {'','',63}, {'','',260}, {'','',114}, {'','',13}, {'','',22}, {'','',33}, {'','',75}, {'','',18}, {'','',5}, {'','',1}, {'','',23}, {'','',6}, {'','',2}, {'','',2}, 
{'','',15}, {'','',14}, {'','',3}, {'','',10}, {'','',23}, {'','',22}, {'','',26}, {'','',18}, {'','',5}, {'','',12}, {'','',17}, {'','',1}, {'','',2}, {'','',28}, {'','',3}, {'','',2}, 
{'','',10}, {'','',7}, {'','',59}, {'','',1264}, {'','',29}, {'','',23}, {'','',129}, {'','',936}, {'','',8}, {'','',53}, {'','',36}, {'','',777}, {'','',1}, {'','',54}, {'','',29}, {'','',39}, 
{'','',181}, {'','',1126}, {'','',38}, {'','',159}, {'','',34}, {'','',76}, {'','',122}, {'','',355}, {'','',41}, {'','',98}, {'','',98}, {'','',169}, {'','',20}, {'','',49}, {'','',7}, {'','',5}, 
{'','',9}, {'','',3}, {'','',4}, {'','',6}, {'','',2}, {'','',2}, {'','',1}, {'','',2}, {'','',1}, {'','',5}, {'','',8}, {'','',10}, {'','',6}, {'','',2}, {'','',4}, {'','',3}, 
{'','',1}, {'','',3}, {'','',2}, {'','',27}, {'','',306}, {'','',33}, {'','',6}, {'','',41}, {'','',973}, {'','',18}, {'','',18}, {'','',34}, {'','',295}, {'','',691}, {'','',519}, {'','',222}, 
{'','',236}, {'','',403}, {'','',274}, {'','',680}, {'','',58}, {'','',222}, {'','',1721}, {'','',146}, {'','',8}, {'','',259}, {'','',401}, {'','',79}, {'','',11}, {'','',20}, {'','',10}, {'','',2}, 
{'','',48}, {'','',6}, {'','',2}, {'','',2}, {'','',4}, {'','',2}, {'','',3}, {'','',4}, {'','',5}, {'','',3}, {'','',3}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, 
{'','',4}, {'','',1}, {'','',3}, {'','',1}, {'','',13}, {'','',1225}, {'','',56}, {'','',10}, {'','',67}, {'','',864}, {'','',1}, {'','',25}, {'','',24}, {'','',758}, {'','',1}, {'','',180}, 
{'','',52}, {'','',65}, {'','',329}, {'','',2625}, {'','',119}, {'','',103}, {'','',616}, {'','',337}, {'','',117}, {'','',398}, {'','',17}, {'','',436}, {'','',1292}, {'','',398}, {'','',33}, {'','',3}, 
{'','',37}, {'','',4}, {'','',87}, {'','',1}, {'','',29}, {'','',5}, {'','',11}, {'','',9}, {'','',2}, {'','',3}, {'','',3}, {'','',16}, {'','',21}, {'','',20}, {'','',24}, {'','',10}, 
{'','',23}, {'','',16}, {'','',2}, {'','',10}, {'','',13}, {'','',2}, {'','',2}, {'','',25}, {'','',5}, {'','',1}, {'','',3}, {'','',11}, {'','',156}, {'','',45}, {'','',142}, {'','',445}, 
{'','',83}, {'','',5}, {'','',161}, {'','',97}, {'','',111}, {'','',40}, {'','',169}, {'','',251}, {'','',322}, {'','',195}, {'','',50}, {'','',258}, {'','',31}, {'','',203}, {'','',380}, {'','',442}, 
{'','',24}, {'','',269}, {'','',184}, {'','',75}, {'','',302}, {'','',19}, {'','',37}, {'','',241}, {'','',22}, {'','',4}, {'','',20}, {'','',3}, {'','',2}, {'','',4}, {'','',5}, {'','',25}, 
{'','',9}, {'','',6}, {'','',12}, {'','',18}, {'','',13}, {'','',18}, {'','',17}, {'','',1}, {'','',18}, {'','',12}, {'','',2}, {'','',19}, {'','',2}, {'','',3}, {'','',5}, {'','',6}, 
{'','',187}, {'','',4}, {'','',145}, {'','',690}, {'','',1}, {'','',1}, {'','',214}, {'','',35}, {'','',1}, {'','',8}, {'','',96}, {'','',13}, {'','',14}, {'','',7}, {'','',7}, {'','',4}, 
{'','',8}, {'','',69}, {'','',4}, {'','',9}, {'','',6}, {'','',1}, {'','',2}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',3}, {'','',1}, {'','',3}, {'','',989}, {'','',26}, 
{'','',11}, {'','',74}, {'','',911}, {'','',1}, {'','',43}, {'','',9}, {'','',387}, {'','',1}, {'','',105}, {'','',122}, {'','',65}, {'','',231}, {'','',1220}, {'','',118}, {'','',48}, {'','',97}, 
{'','',851}, {'','',123}, {'','',116}, {'','',26}, {'','',62}, {'','',33}, {'','',518}, {'','',88}, {'','',53}, {'','',44}, {'','',2}, {'','',47}, {'','',11}, {'','',1}, {'','',1}, {'','',5}, 
{'','',5}, {'','',7}, {'','',8}, {'','',6}, {'','',14}, {'','',2}, {'','',9}, {'','',13}, {'','',17}, {'','',51}, {'','',4}, {'','',7}, {'','',18}, {'','',4}, {'','',2}, {'','',6}, 
{'','',7}, {'','',2}, {'','',2}, {'','',88}, {'','',38}, {'','',63}, {'','',15}, {'','',110}, {'','',154}, {'','',5}, {'','',35}, {'','',20}, {'','',194}, {'','',1}, {'','',324}, {'','',36}, 
{'','',124}, {'','',321}, {'','',92}, {'','',164}, {'','',110}, {'','',41}, {'','',302}, {'','',152}, {'','',48}, {'','',11}, {'','',196}, {'','',58}, {'','',85}, {'','',27}, {'','',1}, {'','',88}, 
{'','',44}, {'','',8}, {'','',18}, {'','',12}, {'','',1}, {'','',7}, {'','',3}, {'','',29}, {'','',19}, {'','',18}, {'','',36}, {'','',25}, {'','',42}, {'','',21}, {'','',4}, {'','',25}, 
{'','',24}, {'','',10}, {'','',1}, {'','',45}, {'','',4}, {'','',1}, {'','',4}, {'','',14}, {'','',10}, {'','',66}, {'','',3}, {'','',65}, {'','',138}, {'','',1}, {'','',37}, {'','',146}, 
{'','',74}, {'','',264}, {'','',83}, {'','',305}, {'','',164}, {'','',141}, {'','',34}, {'','',231}, {'','',10}, {'','',61}, {'','',189}, {'','',148}, {'','',35}, {'','',21}, {'','',248}, {'','',45}, 
{'','',80}, {'','',9}, {'','',1}, {'','',63}, {'','',1}, {'','',14}, {'','',6}, {'','',8}, {'','',6}, {'','',1}, {'','',4}, {'','',12}, {'','',10}, {'','',2}, {'','',15}, {'','',16}, 
{'','',13}, {'','',6}, {'','',10}, {'','',3}, {'','',7}, {'','',10}, {'','',1}, {'','',1}, {'','',28}, {'','',4}, {'','',5}, {'','',4}, {'','',889}, {'','',39}, {'','',174}, {'','',56}, 
{'','',67}, {'','',3}, {'','',113}, {'','',16}, {'','',33}, {'','',64}, {'','',302}, {'','',109}, {'','',31}, {'','',43}, {'','',53}, {'','',21}, {'','',7}, {'','',109}, {'','',18}, {'','',147}, 
{'','',20}, {'','',71}, {'','',11}, {'','',4}, {'','',4}, {'','',11}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',4}, {'','',3}, {'','',1}, {'','',8}, {'','',2}, {'','',4}, 
{'','',2}, {'','',1}, {'','',1}, {'','',2}, {'','',150}, {'','',1}, {'','',388}, {'','',1}, {'','',188}, {'','',201}, {'','',68}, {'','',4}, {'','',78}, {'','',53}, {'','',8}, {'','',3}, 
{'','',2}, {'','',17}, {'','',45}, {'','',5}, {'','',200}, {'','',1}, {'','',1}, {'','',1}, {'','',2}, {'','',2}, {'','',1}, {'','',1}, {'','',6}, {'','',9}, {'','',6}, {'','',3}, 
{'','',8}, {'','',4}, {'','',531}, {'','',1}, {'','',2}, {'','',1}, {'','',68}, {'','',242}, {'','',96}, {'','',7}, {'','',1}, {'','',1}, {'','',3}, {'','',20}, {'','',2}, {'','',1}, 
{'','',1}, {'','',294}, {'','',1}, {'','',874}, {'','',319}, {'','',76}, {'','',9}, {'','',4}, {'','',158}, {'','',10}, {'','',3}, {'','',1}, {'','',8}, {'','',2}, {'','',536}, {'','',101}, 
{'','',6}, {'','',49}, {'','',37}, {'','',7}, {'','',1}, {'','',1}, {'','',1}, {'','',3}, {'','',1}, {'','',3}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, 
{'','',6}, {'','',7}, {'','',23}, {'','',1}, {'','',5}, {'','',6}, {'','',4}, {'','',1}, {'','',27}, {'','',15}, {'','',10}, {'','',25}, {'','',21}, {'','',51}, {'','',20}, {'','',12}, 
{'','',13}, {'','',31}, {'','',15}, {'','',2}, {'','',60}, {'','',6}, {'','',8}, {'','',17}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',8}, {'','',2}, 
{'','',2}, {'','',1}, {'','',4}, {'','',2}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',3}, {'','',16}, {'','',1}, {'','',4}, {'','',3}, {'','',25}, {'','',10}, 
{'','',9}, {'','',2}, {'','',8}, {'','',1}, {'','',2}, {'','',1}, {'','',1}, {'','',7}, {'','',3}, {'','',1}, {'','',1}, {'','',1}, {'','',167}, {'','',17}, {'','',3}, {'','',7}, 
{'','',3}, {'','',1}, {'','',20}, {'','',9}, {'','',19}, {'','',6}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',5}, {'','',2}, {'','',19}, {'','',69}, {'','',9}, 
{'','',5}, {'','',2}, {'','',1}, {'','',1}, {'','',7}, {'','',2}, {'','',2}, {'','',1}, {'','',16}, {'','',1}, {'','',6}, {'','',16}, {'','',26}, {'','',4}, {'','',3}, {'','',1}, 
{'','',31}, {'','',7}, {'','',2}, {'','',2}, {'','',8}, {'','',3}, {'','',20}, {'','',14}, {'','',1}, {'','',1}, {'','',2}, {'','',8}, {'','',20}, {'','',7}, {'','',2}, {'','',7}, 
{'','',3}, {'','',3}, {'','',27}, {'','',15}, {'','',11}, {'','',21}, {'','',26}, {'','',21}, {'','',12}, {'','',4}, {'','',21}, {'','',37}, {'','',5}, {'','',1}, {'','',78}, {'','',17}, 
{'','',1}, {'','',2}, {'','',8}, {'','',1}, {'','',2}, {'','',2}, {'','',2}, {'','',1}, {'','',100}, {'','',4}, {'','',1}, {'','',14}, {'','',4}, {'','',62}, {'','',2}, {'','',24}, 
{'','',10}, {'','',62}, {'','',3}, {'','',3}, {'','',7}, {'','',11}, {'','',4}, {'','',12}, {'','',1}, {'','',15}, {'','',1}, {'','',1}, {'','',2}, {'','',31}, {'','',10}, {'','',1}, 
{'','',44}, {'','',1}, {'','',19}, {'','',93}, {'','',1}, {'','',6}, {'','',3}, {'','',29}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',56}, {'','',111}, {'','',47}, {'','',2}, 
{'','',98}, {'','',100}, {'','',2}, {'','',3}, {'','',1}, {'','',18}, {'','',20}, {'','',4}, {'','',2}, {'','',7}, {'','',9}, {'','',2}, {'','',96}, {'','',5}, {'','',17}, {'','',16}, 
{'','',21}, {'','',35}, {'','',1}, {'','',2}, {'','',6}, {'','',1}, {'','',13}, {'','',2}, {'','',6}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',1}, {'','',18}, {'','',148}, 
{'','',11}, {'','',9}, {'','',186}, {'','',43}, {'','',38}, {'','',4}, {'','',3}, {'','',4}, {'','',8}, {'','',9}, {'','',5}, {'','',3}, {'','',4}, {'','',10}, {'','',5}, {'','',6}, 
{'','',28}, {'','',24}, {'','',39}, {'','',4}, {'','',30}, {'','',7}, {'','',5}, {'','',2}, {'','',49}, {'','',12}, {'','',3}, {'','',3}, {'','',4}, {'','',1}, {'','',22}, {'','',13}, 
{'','',5}, {'','',13}, {'','',1}, {'','',1}, {'','',1}, {'','',19}, {'','',1}, {'','',1}, {'','',56}, {'','',2}, {'','',16}, {'','',22}, {'','',11}, {'','',12}, {'','',6}, {'','',26}, 
{'','',6}, {'','',1}, {'','',6}, {'','',3}, {'','',35}, {'','',4}, {'','',4}, {'','',1}, {'','',1}, {'','',2}, {'','',2}, {'','',3}, {'','',1}, {'','',79}, {'','',18}, {'','',17}, 
{'','',34}, {'','',3}, {'','',11}, {'','',31}, {'','',1}, {'','',2}, {'','',55}, {'','',4}, {'','',1}, {'','',1}, {'','',1}, {'','',2}, {'','',3}, {'','',2}, {'','',1}, {'','',2}, 
{'','',1}, {'','',2}, {'','',1}, {'','',2}, {'','',9}, {'','',5}, {'','',1}, {'','',1}, {'','',9}, {'','',8}, {'','',4}, {'','',3}, {'','',4}, {'','',1}, {'','',1}, {'','',5}, 
{'','',1}, {'','',14}, {'','',5}, {'','',2}, {'','',1}, {'','',15}, {'','',5}, {'','',98}, {'','',3}, {'','',7}, {'','',5}, {'','',8}, {'','',7}, {'','',6}, {'','',107}, {'','',18}, 
{'','',2}, {'','',74}, {'','',6}, {'','',1}, {'','',2}, {'','',39}, {'','',5}, {'','',8}, {'','',3}, {'','',1}, {'','',1}, {'','',2}, {'','',1}, {'','',3}, {'','',8}, {'','',2}, 
{'','',2}, {'','',31}, {'','',1}, {'','',2}, {'','',23}, {'','',2}, {'','',12}, {'','',3}, {'','',1}, {'','',3}, {'','',7}, {'','',8}, {'','',8}, {'','',7}, {'','',1}, {'','',1}, 
{'','',5}, {'','',1}, {'','',1}, {'','',4}, {'','',1}, {'','',10}, {'','',1}, {'','',61}, {'','',1}, {'','',1}, {'','',46}, {'','',60}, {'','',8}, {'','',1}
};

static int indexes=1680;
static int npow=2048;

static int is_win_charset(char *txt, int len){
  const struct lng_stat *winptr, *koiptr;
  int j,ki=0,wi=0,d,l,ws,ks;
  unsigned long koi_stat=0,win_stat=0;
  unsigned char a,b;
  l=strlen(txt);
  if ((len)&&(l>len)) l=len;
  for(j=0;j<l-1;j++){
    a=txt[j];
    b=txt[j+1];
    //skip bottom half of table
    if(a<128 || b<128)
      continue;
    wi=npow>>1;
    ki=npow>>1;
    ws=0;
    ks=0;
    d=npow>>1;
    //binary search through lng_stats
    do{
      d>>=1;
    
      if(!ws){
       if (wi>indexes) wi-=d;
       else {
        winptr=win+wi-1;
        if(a==winptr->a){
          if(b==winptr->b){
            ws=1;
            win_stat+=winptr->rate;
          }else if(b<winptr->b){
            wi-=d;
          }else{ //b>win[wi].b
            wi+=d;
          }
        }else if(a<winptr->a){
          wi-=d;
        }else{ //a>win[wi].a
          wi+=d;
        }
       }
      }
      if(!ks){
       if (ki>indexes) ki-=d;
       else {
        koiptr=koi+ki-1;
        if(a==koiptr->a){
          if(b==koiptr->b){
            ks=1;
            koi_stat+=koiptr->rate;
          }else if(b<koiptr->b){
            ki-=d;
          }else{ //b>win[wi].b
            ki+=d;
          }
        }else if(a<koiptr->a){
          ki-=d;
        }else{ //a>win[wi].a
          ki+=d;
        }
       }
      }
    }while(d);
  }
  if(win_stat>koi_stat)
    return 1;
  else
    return 0;
}

#define NF_VALUE -2
#define max(a,b) ((a>b)?a:b)
#define min(a,b) ((a<b)?a:b)
#define bit(i) (1<<i)

typedef struct lng_stat2 {
  unsigned char a;
  unsigned char b;
  double rate;
  double srate;
  double erate;
} lng_stat2;

#include "russian_table.h"


static int end_symbol(char ch) {
    if (ch=='\r'||ch=='\n'||ch==0||ch==' '||ch=='\t'||ch==','||ch=='.'||ch=='!'||ch=='?'||ch==';'||ch=='-'||ch==':'||ch=='"'||ch=='\''||ch==')') return 1;
    return 0;
}

static int start_symbol(char ch) {
    if ((ch=='\t')||ch=='\r'||ch=='\n'||(ch==' ')||(ch=='(')||(ch=='"')||(ch=='\'')) return 1;
    return 0;
}    

static void bfind(unsigned char *a, const void **w, const void **k, const void **al) {
  const struct lng_stat2 *winptr, *koiptr,*altptr;
  int ki,wi,ai,d,ws=0,ks=0,as=0;
    d=npow2>>1;
    wi=d;
    ki=d;
    ai=d;
    winptr=0;
    koiptr=0;
    altptr=0;
    do{
      d>>=1;
    
      if(!ws){
       if (wi>indexes2) wi-=d;
       else {
        winptr=enc_win+wi-1;
        if(a[0]==winptr->a){
          if(a[1]==winptr->b){
        	ws=1;
          }else if(a[1]<winptr->b){
            wi-=d;
          }else{ //b>win[wi].b
            wi+=d;
          }
        }else if(a[0]<winptr->a){
          wi-=d;
        }else{ //a>win[wi].a
          wi+=d;
        }
       }
      }
      if(!ks){
       if (ki>indexes2) ki-=d;
       else {
        koiptr=enc_koi+ki-1;
        if(a[0]==koiptr->a){
          if(a[1]==koiptr->b){
        	ks=1;
          }else if(a[1]<koiptr->b){
            ki-=d;
          }else{ //b>win[wi].b
            ki+=d;
          }
        }else if(a[0]<koiptr->a){
          ki-=d;
        }else{ //a>win[wi].a
          ki+=d;
        }
       }
      }
      if(!as){
       if (ai>indexes2) ai-=d;
       else {
        altptr=enc_alt+ai-1;
        if(a[0]==altptr->a){
          if(a[1]==altptr->b){
        	as=1;
          }else if(a[1]<altptr->b){
            ai-=d;
          }else{ //b>win[wi].b
            ai+=d;
          }
        }else if(a[0]<altptr->a){
          ai-=d;
        }else{ //a>win[wi].a
          ai+=d;
        }
       }
      }
    }while(d);
    if (ws) *w=winptr;
    else *w=NULL;
    if (ks) *k=koiptr;
    else *k=NULL;
    if (as) *al=altptr;
    else *al=NULL;
}

static double calculate(double s, double m, double e) {
    return s+m+e;
}

static int is_win_charset2(unsigned char *txt, int len){
  const struct lng_stat2 *winptr, *koiptr,*altptr;
  double winstep,koistep,altstep,winestep,koiestep,altestep,winsstep,koisstep,altsstep;
  double winstat=0,koistat=0,altstat=0,winestat=0,koiestat=0,altestat=0,winsstat=0,koisstat=0,altsstat=0;
  long j,l;
  
  l=strlen(txt);
  if ((len)&&(l>len)) l=len;
#ifdef _AUTO_DEBUG
  fprintf(stderr,"Word: %s\n",txt);
#endif
  for(j=0;j<l-1;j++){
    //skip bottom half of table
    if(txt[j]<128 || txt[j+1]<128) continue;
#ifdef _AUTO_DEBUG
    fprintf(stderr,"Pair: %c%c",txt[j],txt[j+1]);
#endif
    bfind(txt+j,(const void**)&winptr,(const void**)&koiptr,(const void**)&altptr);

    if ((j==0)||(start_symbol(txt[j-1]))) {
	if (winptr) winsstep=winptr->srate;
	else winsstep=NF_VALUE;
	if (koiptr) koisstep=koiptr->srate;
	else koisstep=NF_VALUE;
	if (altptr) altsstep=altptr->srate;
	else altsstep=NF_VALUE;
	winestep=0;
	koiestep=0;
	altestep=0;
	winstep=0;
	koistep=0;
	altstep=0;
#ifdef _AUTO_DEBUG
	fprintf(stderr,", Win %lf, Koi %lf, Alt: %lf\n",winsstep,koisstep,altsstep);
#endif
    } else if ((j==l-2)||(end_symbol(txt[j+2]))) {
	if (winptr) winestep=winptr->erate;
	else winestep=NF_VALUE;
	if (koiptr) koiestep=koiptr->erate;
	else koiestep=NF_VALUE;
	if (altptr) altestep=altptr->erate;
	else altestep=NF_VALUE;
	winsstep=0;
	koisstep=0;
	altsstep=0;
	winstep=0;
	koistep=0;
	altstep=0;
#ifdef _AUTO_DEBUG
	fprintf(stderr,", Win %lf, Koi %lf, Alt %lf\n",winestep,koiestep,altestep);
#endif
    } else {
	if (winptr) winstep=winptr->rate;
	else winstep=NF_VALUE;
	if (koiptr) koistep=koiptr->rate;
	else koistep=NF_VALUE;
	if (altptr) altstep=altptr->rate;
	else altstep=NF_VALUE;
	winsstep=0;
	winestep=0;
	koisstep=0;
	koiestep=0;
	altsstep=0;
	altestep=0;
#ifdef _AUTO_DEBUG
	fprintf(stderr,", Win %lf, Koi %lf, Alt %lf\n",winstep,koistep,altstep);
#endif
    }
    
    winstat+=winstep;
    koistat+=koistep;
    altstat+=altstep;
    winsstat+=winsstep;
    koisstat+=koisstep;
    altsstat+=altsstep;
    winestat+=winestep;
    koiestat+=koiestep;
    altestat+=altestep;
  }
  
#ifdef _AUTO_DEBUG
  fprintf(stderr,"Start.  Win: %lf, Koi: %lf, Alt: %lf\n",winsstat,koisstat,altsstat);
  fprintf(stderr,"Middle. Win: %lf, Koi: %lf, Alt: %lf\n",winstat,koistat,altstat);
  fprintf(stderr,"End.    Win: %lf, Koi: %lf, Alt: %lf\n",winestat,koiestat,altestat);
  fprintf(stderr,"Final.  Win: %lf, Koi: %lf, Alt: %lf\n",calculate(winsstat,winstat,winestat),calculate(koisstat,koistat,koiestat),calculate(altsstat,altstat,altestat));
#endif
  if ((calculate(altsstat,altstat,altestat)>calculate(koisstat,koistat,koiestat))&&(calculate(altsstat,altstat,altestat)>calculate(winsstat,winstat,winestat))) return 3;
  if (calculate(koisstat,koistat,koiestat)>calculate(winsstat,winstat,winestat)) return 1;
  return 0;
}


static int check_utf8(unsigned char *buf, int len) {
    long i,j;
    int bytes=0,rflag=0;
    unsigned char tmp;
    int res=0;
    long l;

    l=strlen(buf);
    if ((len)&&(l>len)) l=len;

    for (i=0;i<l;i++) {
	if (buf[i]<128) continue;
	
	if (bytes>0) {
	    if ((buf[i]&0xC0)==0x80) {
		if (rflag) {
		    tmp=buf[i]&0x3F;
		    // Russian is 0x410-0x44F
		    if ((rflag==1)&&(tmp>=0x10)) res++;
		    else if ((rflag==2)&&(tmp<=0x0F)) res++;
		}
		bytes--;
	    } else {
		res--;
		bytes=1-bytes;
		rflag=0;
	    }
	} else {
	    for (j=6;j>=0;j--)
		if ((buf[i]&bit(j))==0) break;
	    
	    if ((j==0)||(j==6)) {
		if ((j==6)&&(bytes<0)) bytes++;
		else res--;
		continue;
	    }
	    bytes=6-j;
	    if (bytes==1) {
		// Cyrrilic D0-D3, Russian - D0-D1
		if (buf[i]==0xD0) rflag=1;
		else if (buf[i]==0xD1) rflag=2;
	    }
	}
	    
	if ((buf[i]==0xD0)||(buf[i]==0xD1)) {
	    if (i+1==l) break;
	    	    
	}
    }
    return res;
}

static int check_cp866(unsigned char *buf, int len) {
    long i;
    int res=0;
    long l;

    l=strlen(buf);
    if ((len)&&(l>len)) l=len;

    for (i=0;i<l;i++) {
	if ((buf[i]>=0x80)&&(buf[i]<=0x9F)) res++;
	else if ((buf[i]>=0xA0)&&(buf[i]<=0xAF)) res++;
	else if ((buf[i]>=0xC0)&&(buf[i]<0xE0)) res-=2;
	else if (buf[i]>0xF1) res-=1;
//	else if ((buf[i]>127)&&(buf[i]<0xC0)) res--;
    }
    return res;
}

int autocharset_russian(char *buf,int len) {
    if (check_utf8(buf,len)>1) return 2;
    if (check_cp866(buf,len)>1) return 3;
    if (is_win_charset(buf,len)) return 0;
    return 1;
}

int autocharset_russian_uc(char *buf,int len) {
    if (check_utf8(buf,len)>1) return 2;
    return is_win_charset2(buf,len);
}
