/* Originaly stealed from GPPL's (http://gppl.terminal.ru) autorecode-xmms1.2.7 patch,
 changed to support limited size strings (not null terminated) 
 
 csa18: Tables regenerated, Fixed binary search algorithm(start and end of the table realy not used
 in original version), UTF-8 support added.
*/

#define max(a,b) ((a>b)?a:b)
#define min(a,b) ((a<b)?a:b)

typedef struct lng_stat {
  unsigned char a;
  unsigned char b;
  unsigned long rate;
  unsigned long srate;
  unsigned long erate;
} lng_stat;

typedef struct lng_stat3 {
  unsigned char a;
  unsigned char b;
  unsigned char c;
  unsigned long rate;
} lng_stat3;

#include "russian_table.h"

static int cmpf(void *a, void *b) {
    if (*(double*)a<*(double*)b) return -1;
    else if (*(double*)a>*(double*)b) return 1;
    return 0;
}

static int end_symbol(char ch) {
    if (ch=='\r'||ch=='\n'||ch==0||ch==' '||ch=='\t'||ch==','||ch=='.'||ch=='!'||ch=='?'||ch==';'||ch=='-'||ch==':'||ch=='"'||ch=='\''||ch==')') return 1;
    return 0;
}

static int start_symbol(char ch) {
    if ((ch=='\t')||ch=='\r'||ch=='\n'||(ch==' ')||(ch=='(')||(ch=='"')||(ch=='\'')) return 1;
    return 0;
}    

void bfind3(long npow, long indexes, unsigned char *a, const void **win, const void **koi) {
  const struct lng_stat3 *winptr, *koiptr;
  int j,ki=0,wi=0,d,l,ws,ks;
    wi=npow>>1;
    ki=npow>>1;
    ws=0;
    ks=0;
    d=npow>>1;
    winptr=0;
    koiptr=0;
    do{
      d>>=1;
    
      if(!ws){
       if (wi>indexes) wi-=d;
       else {
        winptr=win3+wi-1;
        if(a[0]==winptr->a){
          if(a[1]==winptr->b){
	    if (a[2]==winptr->c){
        	ws=1;
	    } else if (a[2]<winptr->c) {
		wi-=d;
	    } else {
		wi+=d;
	    }
          }else if(a[1]<winptr->b){
            wi-=d;
          }else{ //b>win[wi].b
            wi+=d;
          }
        }else if(a[0]<winptr->a){
          wi-=d;
        }else{ //a>win[wi].a
          wi+=d;
        }
       }
      }
      if(!ks){
       if (ki>indexes) ki-=d;
       else {
        koiptr=koi3+ki-1;
        if(a[0]==koiptr->a){
          if(a[1]==koiptr->b){
	    if (a[2]==koiptr->c) {
        	ks=1;
	    } else if (a[2]<koiptr->c) {
		ki-=d;
	    } else {
		ki+=d;
	    }
          }else if(a[1]<koiptr->b){
            ki-=d;
          }else{ //b>win[wi].b
            ki+=d;
          }
        }else if(a[0]<koiptr->a){
          ki-=d;
        }else{ //a>win[wi].a
          ki+=d;
        }
       }
      }
    }while(d);
//    puts(a);
//    printf("%c %c %c\n",winptr->a,winptr->b, winptr->c);
//    printf("%p %p\n",winptr,koiptr);
    if (ws) *win=winptr;
    else *win=NULL;
    if (ks) *koi=koiptr;
    else *koi=NULL;
}

static int
is_win_charset(unsigned char *txt, int len){
  const struct lng_stat *winptr, *koiptr;
  const struct lng_stat3 *winptr3, *koiptr3;
  int j,ki=0,wi=0,d,l,ws,ks;
  long koi_stat=0,win_stat=0;
  double winstep,koistep,winestep,koiestep,winsstep,koisstep;
  double winstat=0,koistat=0,winestat=0,koiestat=0,winsstat=0,koisstat=0;
  long koblom=0, woblom=0,wwins=0,kwins=0;
  double ksstat[255],wsstat[255];
  double ksum=0,wsum=0;
  double ekrate=0,ewrate=0;
  int istep;
  int step=0;
  unsigned char a,b;
  l=strlen(txt);
  if ((len)&&(l>len)) l=len;
#ifdef _AUTO_DEBUG
  fprintf(stderr,"Word: %s\n",txt);
#endif
  for(j=0;j<l-1;j++){
    a=txt[j];
    b=txt[j+1];
    //skip bottom half of table
    if(a<128 || b<128) continue;
#ifdef _AUTO_DEBUG
    fprintf(stderr,"Pair: %c%c",a,b);
#endif
    wi=npow>>1;
    ki=npow>>1;
    ws=0;
    ks=0;
    d=npow>>1;
    //binary search through lng_stats
    do{
      d>>=1;
    
      if(!ws){
       if (wi>indexes) wi-=d;
       else {
        winptr=win+wi-1;
        if(a==winptr->a){
          if(b==winptr->b){
            ws=1;
            win_stat+=winptr->rate;
	    winstep=log10(winptr->rate);
	    if ((j==0)||(start_symbol(txt[j-1]))) {
		if (winptr->srate) winsstep=log10(winptr->srate);
		else { winsstep=-2; woblom++; }
	    } else winsstep=0;
	    
	    if ((j==l-2)||(end_symbol(txt[j+2]))) {
		if (winptr->erate) winestep=log10(winptr->erate);
		else { winestep=-2; woblom++; }
	    } else winestep=0;
#ifdef _AUTO_DEBUG
	    fprintf(stderr,", Win %lu",winptr->rate);
#endif
          }else if(b<winptr->b){
            wi-=d;
          }else{ //b>win[wi].b
            wi+=d;
          }
        }else if(a<winptr->a){
          wi-=d;
        }else{ //a>win[wi].a
          wi+=d;
        }
       }
      }
      if(!ks){
       if (ki>indexes) ki-=d;
       else {
        koiptr=koi+ki-1;
        if(a==koiptr->a){
          if(b==koiptr->b){
            ks=1;
            koi_stat+=koiptr->rate;
	    koistep=log10(koiptr->rate);
	    if ((j==0)||(start_symbol(txt[j-1]))) {
		if (koiptr->srate) koisstep=log10(koiptr->srate);
		else { koisstep=-2; koblom++; }
	    } else koisstep=0;
	    if ((j==l-2)||(end_symbol(txt[j+2]))) {
		if (koiptr->erate) koiestep=log10(koiptr->erate);
		else { koiestep=-2; koblom++; }
	    } else koiestep=0;
#ifdef _AUTO_DEBUG
	    fprintf(stderr,", Koi %lu",koiptr->rate);
#endif
          }else if(b<koiptr->b){
            ki-=d;
          }else{ //b>win[wi].b
            ki+=d;
          }
        }else if(a<koiptr->a){
          ki-=d;
        }else{ //a>win[wi].a
          ki+=d;
        }
       }
      }
    }while(d);
#ifdef _AUTO_DEBUG
    fprintf(stderr,"\n");
#endif
    if (!ws) {
	    if ((j!=0)&&(j!=l-2)&&(!start_symbol(txt[j-1]))&&(!end_symbol(txt[j+2]))) winstep=-2;
	if ((j==0)||(start_symbol(txt[j-1]))) { winsstep=-2; woblom++; }
	else winsstep=0;
	if ((j==l-2)||(end_symbol(txt[j+2]))) { winestep=-2; woblom++; }
	else winestep=0;
    }
    if (!ks) {
	if ((j!=0)&&(j!=l-2)&&(!start_symbol(txt[j-1]))&&(!end_symbol(txt[j+2]))) koistep=-2;
	if ((j==0)||(start_symbol(txt[j-1]))) { koisstep=-2; koblom++; }
	else koisstep=0;
	if ((j==l-2)||(end_symbol(txt[j+2]))) { koiestep=-2; koblom++; }
	else koiestep=0;
    }
    if ((j!=0)&&(j!=l-2)&&(!start_symbol(txt[j-1]))&&(!end_symbol(txt[j+2]))) {
	winstat+=winstep;
	koistat+=koistep;
    }
    winsstat+=winsstep;
    koisstat+=koisstep;
    winestat+=winestep;
    koiestat+=koiestep;
    wsstat[step]=winstep;
    ksstat[step++]=koistep;
  }
  qsort(ksstat,step,sizeof(double),cmpf);
  qsort(wsstat,step,sizeof(double),cmpf);
  
  for (istep=1;istep<step-1;istep++) {
    wsum+=wsstat[istep];
    ksum+=ksstat[istep];
  }

  for(j=1;j<l-2;j++){
    if(txt[j]<128 || txt[j+1]<128 || txt[j+2]<128 ) continue;
    if (start_symbol(txt[j-1])) continue;
    if ((j!=l-3)&&(!end_symbol(txt[j+3]))) continue;
    bfind3(npow3,indexes3,txt+j,(const void**)&winptr3,(const void**)&koiptr3);
    if (winptr3) ewrate+=log10(winptr3->rate);
    else ewrate-=1;
    if (koiptr3) ekrate+=log10(koiptr3->rate);
    else ekrate-=1;
  }
  
#ifdef _AUTO_DEBUG
  fprintf(stderr,"Winm: %lf, Koim: %lf\n",wsstat[0],ksstat[0]);
  fprintf(stderr,"WinM: %lf, KoiM: %lf\n",wsstat[step/2],ksstat[step/2]);
  fprintf(stderr,"WinL: %lf, KoiL: %lf\n",winstat,koistat);
  fprintf(stderr,"WinS: %lf, KoiS: %lf\n",winsstat,koisstat);
  fprintf(stderr,"WinE: %lf, KoiE: %lf\n",winestat,koiestat);
  fprintf(stderr,"WinU: %lf, KoiU: %lf\n",wsum,ksum);
  fprintf(stderr,"Win3: %lf, Koi3: %lf\n",ewrate,ekrate);
  fprintf(stderr,"WinF: %lf, Koif: %lf\n",winstat*2+winsstat+winestat/2+ewrate/2,koistat*2+koisstat+koiestat/2+ekrate/2);
  fprintf(stderr,"Win: %i, Koi: %i\n\n",win_stat,koi_stat);
#endif

//  if ((winstat-koistat)>1) return 1;
//  else if ((koistat-winstat)>1) return 0;
/*
  if (wsum>ksum) wwins++;
  else if (wsum<ksum) wwins--;
  if (winsstat>koisstat) wwins++;
  else if (koisstat>winsstat) wwins--;
  if (winestat>koiestat) wwins++;
  else if (koiestat>winestat) wwins--;
  if (winstat>koistat) wwins++;
  else if (koistat>winstat) wwins--;
  if (wsstat[0]>ksstat[0]) wwins++;
  else if (wsstat[0]<ksstat[0]) wwins--;
  if (ewrate>ekrate) wwins++;
  else if (ewrate<ekrate) wwins--;
  wwins+=((winstat+winsstat+winestat)-(koistat+koisstat+koiestat))/1;

  if (wwins>2) return 1;
  else if (wwins<-2) return 0;
  if ((ewrate>0)&&(ekrate<0)) return 1;
  if ((ewrate<0)&&(ekrate>0)) return 0;
*/
/*  if (fabs((winstat+winsstat+winestat)-(koistat+koisstat+koiestat))>1) {
     if (winstat+winsstat+winestat>koistat+koisstat+koiestat) return 1;
     else return 0;
  } //else return 2;*/

//  if (fabs((winstat+winsstat+winestat+ewrate)-(koistat+koisstat+koiestat+ekrate))>0) {
     if (winstat+winsstat+winestat/2+ewrate/2>koistat+koisstat+koiestat/2+ekrate/2) return 1;
     else return 0;
//  }// else return 2;

  if (ewrate>ekrate) return 1;
  else if (ewrate<ekrate) return 0;
  
   if (winstat+winsstat+winestat>koistat+koisstat+koiestat) return 1;
   else return 0;
  

 
  if (wwins>1) return 1;
  else if (wwins<-1) return 0;

  if (fabs((winstat+winsstat+winestat+ewrate)-(koistat+koisstat+koiestat+ekrate))>1) {
     if (winstat+winsstat+winestat+ewrate>koistat+koisstat+koiestat+ekrate) return 1;
     else return 0;
  } else return 2;

/*
 if (wsstat[0]>ksstat[0]) return 1;
 else if (wsstat[0]<ksstat[0]) return 0;
    
  if (min(winsstat,winestat)>min(koisstat,koiestat)) return 1;
  else if (min(winsstat,winestat)<min(koisstat,koiestat)) return 0;
*/
  if (winstat>koistat) return 1;
  else return 0;
  
  if(win_stat>koi_stat)
    return 1;
  else
    return 0;
}

/* Only CP1251 and KOI8-R still */
int autocharset_russian(char *buf,int len) {
    int ret=is_win_charset(buf,len);
    if (ret==1) return 0;
    if (ret==2) return 2;
    return 1;
}
