#include <stdio.h>
#include <unistd.h>
#include <ctype.h>
#include <locale.h>
#include <sys/types.h>
#include <sys/stat.h>

#define first_char 192
#define last_char 255

#define chars_number (last_char-first_char+1)
#define array_size (chars_number*chars_number)

struct array_pos {
    int ll;
    int uu;
    int lu;
    int ul;
};

struct pstat {
    unsigned long p;
    unsigned long s;
    unsigned long e;
};

int end_symbol(char ch) {
    if (ch=='\r'||ch=='\n'||ch==0||ch==' '||ch=='\t'||ch==','||ch=='.'||ch=='!'||ch=='?'||ch==';'||ch=='-'||ch==':'||ch=='"'||ch=='\''||ch==')') return 1;
    return 0;
}

int start_symbol(char ch) {
    if ((ch=='\t')||ch=='\r'||ch=='\n'||(ch==' ')||(ch=='(')||(ch=='"')||(ch=='\'')) return 1;
    return 0;
}    


int get_array_pos(struct array_pos *pos, int a, int b) {
    int la,ua,lb,ub;
    if ((a<first_char)||(a>last_char)) return -1;
    if ((b<first_char)||(b>last_char)) return -1;
    
    la=tolower(a);
    ua=toupper(a);
    lb=tolower(b);
    ub=toupper(b);
    if ((la<first_char)||(la>last_char)) la=a;
    if ((lb<first_char)||(lb>last_char)) lb=b;
    if ((ua<first_char)||(ua>last_char)) ua=a;
    if ((ub<first_char)||(ub>last_char)) ub=b;

//    la=a;lb=b;ua=a;ub=b;
    
    pos->ll=(la-first_char)*chars_number+(lb-first_char);
    if (la!=ua) {
	pos->ul=(ua-first_char)*chars_number+(lb-first_char);
    } else {
	pos->ul=-1;
    } 
    if (lb!=ub) {
	pos->lu=(la-first_char)*chars_number+(ub-first_char);
    }
    else {
	pos->lu=-1;
    }
    if ((lb!=ub)&&(la!=ua)) {
	pos->uu=(ua-first_char)*chars_number+(ub-first_char);
    } else {
	pos->uu=-1;
    }
    return 0;
}

int get_array_pos3(struct array_pos *pos, int a, int b, int c) {
    int la,ua,lb,ub,lc,uc;
    if ((a<first_char)||(a>last_char)) return -1;
    if ((b<first_char)||(b>last_char)) return -1;
    if ((c<first_char)||(c>last_char)) return -1;
    
    la=tolower(a);
    ua=toupper(a);
    lb=tolower(b);
    ub=toupper(b);
    lc=tolower(c);
    uc=toupper(c);
    if ((la<first_char)||(la>last_char)) la=a;
    if ((lb<first_char)||(lb>last_char)) lb=b;
    if ((lc<first_char)||(lc>last_char)) lc=c;
    if ((ua<first_char)||(ua>last_char)) ua=a;
    if ((ub<first_char)||(ub>last_char)) ub=b;
    if ((uc<first_char)||(uc>last_char)) uc=c;

    pos->ll=(la-first_char)*chars_number*chars_number+(lb-first_char)*chars_number+(lc-first_char);
    if ((la!=ua)||(lb!=ub)||(lc!=uc)) pos->uu=(ua-first_char)*chars_number*chars_number+(ub-first_char)*chars_number+(uc-first_char);
    else pos->uu=-1;
    return 0;
}


struct pstat *analyze(const unsigned char *text, unsigned long length) {
    struct pstat *a;
    unsigned long i;
    struct array_pos pos;
    
    a=(struct pstat*)malloc(array_size*sizeof(struct pstat));
    if (!a) return NULL;

    for (i=0;i<array_size;i++) {
	a[i].p=0;
	a[i].s=0;
	a[i].e=0;
    }
	
    for (i=1;i<length;i++) {
	if (get_array_pos(&pos,text[i-1],text[i])>=0) {
	    if (pos.ll>=0) {
		a[pos.ll].p++;
		if ((i==1)||(start_symbol(text[i-2]))) a[pos.ll].s++;
		if (end_symbol(text[i+1])) a[pos.ll].e++;
	    }
	    if (pos.ul>=0) {
		a[pos.ul].p++;
		if ((i==1)||(start_symbol(text[i-2]))) a[pos.ul].s++;
		if (end_symbol(text[i+1])) a[pos.ul].e++;
	    }
//	    if (pos.lu>=0) {
//		a[pos.lu].p++;
//		if ((i==1)||(start_symbol(text[i-2]))) a[pos.lu].s++;
//		if (end_symbol(text[i+1])) a[pos.lu].e++;
//	    }
	    if (pos.uu>=0) {
		a[pos.uu].p++;
		if ((i==1)||(start_symbol(text[i-2]))) a[pos.uu].s++;
		if (end_symbol(text[i+1])) a[pos.uu].e++;
	    }
	}
    }
    return a;
}

unsigned long *analyze0(const unsigned char *text, unsigned long length) {
    unsigned long *a;
    unsigned long i;
    unsigned char u,l;
    struct array_pos pos;
    
    a=(unsigned long*)malloc(chars_number*sizeof(unsigned long));
    if (!a) return NULL;

    for (i=0;i<chars_number;i++)
	a[i]=0;
	
    for (i=0;i<length;i++) {
	if ((text[i]<first_char)||(text[i]>last_char)) continue;
	u=toupper(text[i])-first_char;
	l=tolower(text[i])-first_char;
	a[l]++;
	if (l!=u) a[u]++;
    }
    return a;
}

struct pstat *analyze3(const unsigned char *text, unsigned long length) {
    struct pstat *a;
    unsigned long i;
    struct array_pos pos;
    
    a=(struct pstat*)malloc(array_size*chars_number*sizeof(struct pstat));
    if (!a) return NULL;

    for (i=0;i<array_size*chars_number;i++) {
	a[i].p=0;
	a[i].s=0;
	a[i].e=0;
    }
	
    for (i=3;i<length;i++) {
	if (get_array_pos3(&pos,text[i-2],text[i-1],text[i])>=0) {
	    if (pos.ll>=0) {
		if ((end_symbol(text[i+1]))&&(!start_symbol(text[i-3]))) a[pos.ll].e++;
	    }
	    if (pos.uu>=0) {
		if ((end_symbol(text[i+1]))&&(!start_symbol(text[i-3]))) a[pos.uu].e++;
	    }
	}
    }
    return a;
}

int print(struct pstat *a) {
    int i,j,k,n;
    
    for (i=first_char,k=0,n=0;i<=last_char;i++)
	for (j=first_char;j<=last_char;j++,k++) {
	    if (a[k].p) {
		if ((n)&&(n%8==0)) printf(",\n");
		else if (n) printf(", ");
		printf("{'%c','%c',%lu,%lu,%lu}",i,j,a[k].p,a[k].s,a[k].e);
		n++;
	    }
	}
    if ((n%8)!=1) printf("\n");
    return n;
}

void print0(unsigned long *a) {
    int i;
    
    for (i=0;i<chars_number;i++) {
	if (i) printf(", ");
	printf("%lu",a[i]);
    }
}

int print3(struct pstat *a) {
    int h,i,j,k,n;
    
    for (h=first_char,k=0,n=0;h<=last_char;h++)
      for (i=first_char;i<=last_char;i++)
	for (j=first_char;j<=last_char;j++,k++) {
	    if (a[k].e) {
		if ((n)&&(n%8==0)) printf(",\n");
		else if (n) printf(", ");
		printf("{'%c','%c','%c',%lu}",h,i,j,a[k].e);
		n++;
	    }
	}
    if ((n%8)!=1) printf("\n");
    return n;
}


unsigned long npow(unsigned long n) {
    unsigned long res=2;
    while (res<=n) res*=2;
    return res;
}

main(int argc, char *argv[]) {
    FILE *f;
    struct stat st;
    unsigned char *text;
    char locale[32];
    unsigned long len;
    struct pstat *a;
    int num;
    long i,sum;


    if (argc!=3) {
	printf("Usage: %s <file name> <encoding>\n",argv[0]);
	exit(0);
    }

    if (strlen(argv[2])>12) {
	printf("Invalid encoding(%s) specified!\n",argv[2]);
	exit(1);
    }
    
    if ((!strcasecmp(argv[2],"koi"))||(!strcasecmp(argv[2],"koi8"))||(!strcasecmp(argv[2],"koi-8"))||(!strcasecmp(argv[2],"koi8-r")))
    	sprintf(locale,"ru_RU.%s","KOI8-R");
    else if ((!strcasecmp(argv[2],"win"))||(!strcasecmp(argv[2],"cp1251"))||(!strcasecmp(argv[2],"cp-1251"))||(!strcasecmp(argv[2],"win1251"))||(!strcasecmp(argv[2],"win-1251")))
	sprintf(locale,"ru_RU.%s","CP1251");
    else
	sprintf(locale,"ru_RU.%s",argv[2]);
    if (!setlocale(LC_CTYPE,locale)) {
	printf("Can't set locale %s!\n",argv[2]);
	exit(1);
    }
    
    if (stat(argv[1],&st)) {
	printf("Specified file can't be stated!\n");
	exit(1);
    }
    
    if (!S_ISREG(st.st_mode)) {
	printf("Specified file isn't regular file!\n");
	exit(1);
    }
    
    text=(unsigned char*)malloc(st.st_size);
    if (!text) {
	printf("Can't allocate %lu bytes of memory!\n",st.st_size);
	exit(1);
    }
    
    f=fopen(argv[1],"r");
    if (!f) {
	printf("Failed to open specified file. Check permissions!\n");
	free(text);
	exit(1);
    }
    if (fread(text,1,st.st_size,f)!=st.st_size) {
	printf("Problem reading specified file!\n");
	free(text);
	fclose(f);
	exit(1);
    }
    fclose(f);
    
    a=analyze(text,st.st_size);
    if (a) {
	printf("static const lng_stat %s[]={\n",argv[2]);
	num=print(a);
	printf("};\n\n");
	free(a);
	fprintf(stderr,"static unsigned int indexes=%lu;\n",num);
	fprintf(stderr,"static unsigned int npow=%lu;\n",npow(num));
    } else printf("Failed to allocate %lu bytes of memory!\n",array_size*sizeof(struct pstat));

    a=analyze3(text,st.st_size);
    if (a) {
	printf("static const lng_stat3 %s3[]={\n",argv[2]);
	num=print3(a);
	printf("};\n\n");
	fprintf(stdout,"static unsigned int indexes3=%lu;\n",num);
	fprintf(stdout,"static unsigned int npow3=%lu;\n",npow(num));
	free(a);
    } else printf("Failed to allocate %lu bytes of memory!\n",array_size*chars_number*sizeof(struct pstat));

/*
    a=analyze0(text,st.st_size);
    if (a) {
	printf("\n");
	printf("static const unsigned long %s0[]={",argv[2]);
	print0(a);
	printf("};\n\n");
	free(a);
    } else printf("Failed to allocate %lu bytes of memory!\n",chars_number*sizeof(unsigned long));
*/        
    free(text);
}
